% Sumit Basu
% CIS 601
% Fall '04
% Assignment 3

% Read in noise_2.gif
nois18 = imread('noise_2.gif');
nois1=double(nois18); %for further processing you need to convert the image into double
figure; colormap(gray(256)); image(nois1); title('input image') %displays image withouth Image Proc. TB
% image smoothing example
S=1/9*[1 1 1; 1 1 1; 1 1 1] %filter mask for smoothing
smooth1=filter2(S,nois1); %convolution of the image with the filter mask S
figure; image(smooth1); colormap(gray(256)); title('smoothed image obtained by averaging')

% Get the size of the matrix
[m n] = size(nois1);
% Create a new matrix with 2 more rows and 2 more columns
D = zeros((m+2),(n+2));
% Read in the main matrix starting at 2nd row & 2nd column
D([2:(m+1)],[2:(n+1)]) = nois1;
% Create a 3x3 zero matrix
X = zeros(3,3);
M1 = zeros(m,n);
D1 = zeros(m,n);
E1 = zeros(m,n);
Z = zeros(1,9);
for i = 1:1:m
    for j = 1:1:n
        X = D([i:(i+2)],[j:(j+2)]);
        % Read in each 3x3 matrix as a 1x9 vector
        Z(1,[1:3]) = X(1,[1:3]);
        Z(1,[4:6]) = X(2,[1:3]);
        Z(1,[7:9]) = X(3,[1:3]);
        % Get the Median of the 1x9 vector
        M1(i,j) = median(Z);
        % Get the Min of the 1x9 vector
        E1(i,j) = min(Z);
        % Get the Max of the 1x9 vector
        D1(i,j) = max(Z);
    end
end
% Show the Median image
figure; image(M1); colormap(gray(256)); title('Median')
% Show the Erotion image
figure; image(E1); colormap(gray(256)); title('Erosion')
% Show the Dilation image
figure; image(D1); colormap(gray(256)); title('Dilation')

% Now use Dilation o Erosion to get the Opening matrix
O1 = zeros(m,n);
OX = zeros((m+2),(n+2));
OX([2:(m+1)],[2:(n+1)]) = E1;
for i = 1:1:m
    for j = 1:1:n
        X = OX([i:(i+2)],[j:(j+2)]);
        Z(1,[1:3]) = X(1,[1:3]);
        Z(1,[4:6]) = X(2,[1:3]);
        Z(1,[7:9]) = X(3,[1:3]);
        O1(i,j) = max(Z);
   end
end
% Show the Closing image
figure; image(O1); colormap(gray(256)); title('Opening')

% Now use Erotion o Dilation to get the Opening matrix
C1 = zeros(m,n);
DX = zeros((m+2),(n+2));
DX([2:(m+1)],[2:(n+1)]) = D1;
for i = 1:1:m
    for j = 1:1:n
        X = OX([i:(i+2)],[j:(j+2)]);
        Z(1,[1:3]) = X(1,[1:3]);
        Z(1,[4:6]) = X(2,[1:3]);
        Z(1,[7:9]) = X(3,[1:3]);
        C1(i,j) = min(Z);
    end
end
% Show the Opening image
figure; image(C1); colormap(gray(256)); title('Closing')

